ALTER TABLE HabitCategory RENAME TO HabitCategory_old;
CREATE TABLE HabitCategory( HabitCategoryId INTEGER NOT NULL PRIMARY KEY,HabitCategoryLevel1Name TEXT NOT NULL,HabitCategoryLevel2Name TEXT NOT NULL UNIQUE,DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')) );
INSERT INTO HabitCategory SELECT * FROM HabitCategory_old;
DROP TABLE HabitCategory_old;
ALTER TABLE AppSetting RENAME TO AppSetting_old;
CREATE TABLE AppSetting( AppSettingId INTEGER NOT NULL PRIMARY KEY,SettingName TEXT NOT NULL UNIQUE,SettingValue TEXT NOT NULL,DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')) );
INSERT INTO AppSetting SELECT * FROM AppSetting_old;
DROP TABLE AppSetting_old;
ALTER TABLE Comment RENAME TO Comment_old;
CREATE TABLE Comment( CommentId INTEGER NOT NULL PRIMARY KEY,CommentText TEXT NOT NULL, DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')) );
INSERT INTO Comment SELECT * FROM Comment_old;
DROP TABLE Comment_old;
ALTER TABLE QuotePack RENAME TO QuotePack_old;
CREATE TABLE QuotePack( QuotePackId INTEGER NOT NULL PRIMARY KEY,QuotePackName TEXT NOT NULL UNIQUE,DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')) );
INSERT INTO QuotePack SELECT * FROM QuotePack_old;
DROP TABLE QuotePack_old;
ALTER TABLE DataCollectDeletedRows RENAME TO DataCollectDeletedRows_old;
CREATE TABLE DataCollectDeletedRows( DataCollectDeletedRowsId INTEGER NOT NULL PRIMARY KEY,TableName TEXT NOT NULL,RowIdDeleted INTEGER NOT NULL,DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')));
INSERT INTO DataCollectDeletedRows SELECT * FROM DataCollectDeletedRows_old;
DROP TABLE DataCollectDeletedRows_old;
ALTER TABLE Habit RENAME TO Habit_old;
CREATE TABLE Habit( HabitId INTEGER NOT NULL PRIMARY KEY,HabitTypeId INTEGER NOT NULL REFERENCES HabitType(HabitTypeId),HabitCategoryId INTEGER NOT NULL REFERENCES HabitCategory(HabitCategoryId) ON DELETE CASCADE,ColourId INTEGER NOT NULL REFERENCES Colour(ColourId),HabitName TEXT NOT NULL UNIQUE,HabitDescription TEXT NOT NULL,HabitOrder INTEGER NOT NULL DEFAULT(0),HabitDefaultValue REAL NOT NULL DEFAULT(0),CurrentStreakValue INTEGER NOT NULL DEFAULT(0),IsActive INTEGER NOT NULL DEFAULT(1),DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')), CurrentQuoteId INT NULL REFERENCES Quote(QuoteId));
INSERT INTO Habit SELECT * FROM Habit_old;
DROP TABLE Habit_old;
ALTER TABLE CommentMapping RENAME TO CommentMapping_old;
CREATE TABLE CommentMapping( CommentMappingId INTEGER NOT NULL PRIMARY KEY,CalendarDateId INTEGER NOT NULL REFERENCES CalendarDate(CalendarDateId),HabitId INTEGER NOT NULL REFERENCES Habit(HabitId) ON DELETE CASCADE,CommentId INTEGER NOT NULL REFERENCES Comment(CommentId) ON DELETE CASCADE,DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')),UNIQUE(CalendarDateId, HabitId) );
INSERT INTO CommentMapping SELECT * FROM CommentMapping_old;
DROP TABLE CommentMapping_old;
ALTER TABLE Goal RENAME TO Goal_old;
CREATE TABLE Goal( GoalId INTEGER NOT NULL PRIMARY KEY,HabitId INTEGER NOT NULL UNIQUE REFERENCES Habit(HabitId) ON DELETE CASCADE,GoalTypeId INTEGER NOT NULL REFERENCES GoalType(GoalTypeId),GoalOccurrenceValue INTEGER NOT NULL DEFAULT(1),IsCurrent INTEGER NOT NULL DEFAULT(1),EffectiveFrom TEXT NOT NULL DEFAULT(DATE(strftime('%Y-%m-%d %H:%M:%f', 'now'))),EffectiveTo TEXT NOT NULL DEFAULT(DATE('9999-12-31')),DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')) );
INSERT INTO Goal SELECT * FROM Goal_old;
DROP TABLE Goal_old;
ALTER TABLE HabitData RENAME TO HabitData_old;
CREATE TABLE HabitData( HabitDataId INTEGER NOT NULL PRIMARY KEY,HabitId INTEGER NOT NULL REFERENCES Habit(HabitId) ON DELETE CASCADE,CalendarDateId INTEGER NOT NULL REFERENCES CalendarDate(CalendarDateId),Value REAL NOT NULL,DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')),UNIQUE(HabitId, CalendarDateId) );
INSERT INTO HabitData SELECT * FROM HabitData_old;
DROP TABLE HabitData_old;
ALTER TABLE HabitDetail RENAME TO HabitDetail_old;
CREATE TABLE HabitDetail( HabitDetailId INTEGER NOT NULL PRIMARY KEY,HabitId INTEGER NOT NULL UNIQUE REFERENCES Habit(HabitId) ON DELETE CASCADE,StreakOperatorId INTEGER NOT NULL REFERENCES StreakOperator(StreakOperatorId),Grain REAL NOT NULL DEFAULT(0.0),MaxThreshold REAL NOT NULL DEFAULT(0.0),MinThreshold REAL NOT NULL DEFAULT(0.0),StreakBound REAL NOT NULL DEFAULT(0),IsIncreasePositive INTEGER NOT NULL DEFAULT(0),IsRangeBound INTEGER NOT NULL DEFAULT(0),IsCurrent INTEGER NOT NULL DEFAULT(1),EffectiveFrom TEXT NOT NULL DEFAULT(DATE(strftime('%Y-%m-%d %H:%M:%f', 'now'))),EffectiveTo TEXT NOT NULL DEFAULT(DATE('9999-12-31')),DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')), ReminderTime TEXT NOT NULL DEFAULT('00:00:00'), IsReminderEnabled INTEGER NOT NULL DEFAULT(0));
INSERT INTO HabitDetail SELECT * FROM HabitDetail_old;
DROP TABLE HabitDetail_old;
ALTER TABLE Reminder RENAME TO Reminder_old;
CREATE TABLE Reminder( ReminderId INTEGER NOT NULL PRIMARY KEY,HabitId INTEGER NOT NULL REFERENCES Habit(HabitId) ON DELETE CASCADE,CalendarWeekdayId INTEGER NOT NULL REFERENCES CalendarWeekday(CalendarWeekdayId),IsRecurring INTEGER NOT NULL DEFAULT(0),StartTime INTEGER NOT NULL,EndTime INTEGER NOT NULL,DailyRecurringInterval INTEGER NOT NULL DEFAULT(0),IntraDayRecurringInterval INTEGER NOT NULL DEFAULT(0),IsSoundEnabled INTEGER NOT NULL DEFAULT(0),IsVibrateEnabled INTEGER NOT NULL DEFAULT(0),IsDisabledOnSuccessfulDay INTEGER NOT NULL DEFAULT(0),IsActive INTEGER NOT NULL DEFAULT(1),DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')), UNIQUE(HabitId, CalendarWeekdayId, IsRecurring, StartTime, EndTime, DailyRecurringInterval, IntraDayRecurringInterval) );
INSERT INTO Reminder SELECT * FROM Reminder_old;
DROP TABLE Reminder_old;
ALTER TABLE GoalWeekday RENAME TO GoalWeekday_old;
CREATE TABLE GoalWeekday( GoalWeekdayId INTEGER NOT NULL PRIMARY KEY,GoalId INTEGER NOT NULL REFERENCES Goal(GoalId) ON DELETE CASCADE,CalendarWeekdayId INTEGER NOT NULL REFERENCES CalendarWeekday(CalendarWeekdayId),DateModified TEXT NOT NULL DEFAULT(strftime('%Y-%m-%d %H:%M:%f', 'now')),UNIQUE(GoalId, CalendarWeekdayId) );
INSERT INTO GoalWeekday SELECT * FROM GoalWeekday_old;
DROP TABLE GoalWeekday_old;
CREATE INDEX ix_GoalWeekday_CalendarWeekdayId ON GoalWeekday(CalendarWeekdayId);
CREATE TRIGGER delete_ExtractRowIdFromAppSetting AFTER DELETE ON AppSetting FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(),'AppSetting',old.AppSettingId; DELETE FROM AppSetting_GK WHERE AppSettingId = old.AppSettingId; END;
CREATE TRIGGER delete_ExtractRowIdFromComment AFTER DELETE ON Comment FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'Comment',old.CommentId; DELETE FROM Comment_GK WHERE CommentId = old.CommentId; END;
CREATE TRIGGER delete_ExtractRowIdFromCommentMapping AFTER DELETE ON CommentMapping FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'CommentMapping',old.CommentMappingId; DELETE FROM CommentMapping_GK WHERE CommentMappingId = old.CommentMappingId; END;
CREATE TRIGGER delete_ExtractRowIdFromGoal AFTER DELETE ON Goal FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'Goal',old.GoalId; DELETE FROM Goal_GK WHERE GoalId = old.GoalId;  DELETE FROM Habit WHERE HabitId = old.HabitId; END;
CREATE TRIGGER delete_ExtractRowIdFromGoalWeekday AFTER DELETE ON GoalWeekday FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'GoalWeekday',old.GoalWeekdayId; DELETE FROM GoalWeekday_GK WHERE GoalWeekdayId = old.GoalWeekdayId; END;
CREATE TRIGGER delete_ExtractRowIdFromHabit AFTER DELETE ON Habit FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'Habit',old.HabitId; DELETE FROM Habit_GK WHERE HabitId = old.HabitId; END;
CREATE TRIGGER delete_ExtractRowIdFromHabitCategory AFTER DELETE ON HabitCategory FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'HabitCategory',old.HabitCategoryId; DELETE FROM HabitCategory_GK WHERE HabitCategoryId = old.HabitCategoryId; END;
CREATE TRIGGER delete_ExtractRowIdFromHabitData AFTER DELETE ON HabitData FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'HabitData',old.HabitDataId; DELETE FROM HabitData_GK WHERE HabitDataId = old.HabitDataId; END;
CREATE TRIGGER delete_ExtractRowIdFromHabitDetail AFTER DELETE ON HabitDetail FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'HabitDetail',old.HabitDetailId; DELETE FROM HabitDetail_GK WHERE HabitDetailId = old.HabitDetailId; DELETE FROM Habit WHERE HabitId = old.HabitId; END;
CREATE TRIGGER delete_ExtractRowIdFromQuotePack AFTER DELETE ON QuotePack FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'QuotePack',old.QuotePackId; DELETE FROM QuotePack_GK WHERE QuotePackId = old.QuotePackId; END;
CREATE TRIGGER delete_ExtractRowIdFromReminder AFTER DELETE ON Reminder FOR EACH ROW BEGIN INSERT OR REPLACE INTO DataCollectDeletedRows( DataCollectDeletedRowsId,TableName,RowIdDeleted ) SELECT random(), 'Reminder',old.ReminderId; DELETE FROM Reminder_GK WHERE ReminderId = old.ReminderId; END;
CREATE TABLE HabitCategory_GK( HabitCategoryId INTEGER NOT NULL PRIMARY KEY, HabitCategoryLevel2Name TEXT NOT NULL UNIQUE);
CREATE TABLE AppSetting_GK( AppSettingId INTEGER NOT NULL PRIMARY KEY,SettingName TEXT NOT NULL UNIQUE);
CREATE TABLE Comment_GK( CommentId INTEGER NOT NULL PRIMARY KEY,CommentText TEXT NOT NULL UNIQUE);
CREATE TABLE GoalWeekday_GK( GoalWeekdayId INTEGER NOT NULL PRIMARY KEY,GoalId INTEGER NOT NULL,CalendarWeekdayId INTEGER NOT NULL, UNIQUE(GoalId, CalendarWeekdayId) );
CREATE TABLE QuotePack_GK( QuotePackId INTEGER NOT NULL PRIMARY KEY,QuotePackName TEXT NOT NULL UNIQUE);
CREATE TABLE Habit_GK( HabitId INTEGER NOT NULL PRIMARY KEY, HabitName TEXT NOT NULL UNIQUE);
CREATE TABLE CommentMapping_GK( CommentMappingId INTEGER NOT NULL PRIMARY KEY,CalendarDateId INTEGER NOT NULL, HabitId INTEGER NOT NULL,UNIQUE(CalendarDateId, HabitId) );
CREATE TABLE HabitData_GK( HabitDataId INTEGER NOT NULL PRIMARY KEY,HabitId INTEGER NOT NULL, CalendarDateId INTEGER NOT NULL, UNIQUE(HabitId, CalendarDateId) );
CREATE TABLE Goal_GK( GoalId INTEGER NOT NULL PRIMARY KEY,HabitId INTEGER NOT NULL, UNIQUE(HabitId) );
CREATE TABLE HabitDetail_GK( HabitDetailId INTEGER NOT NULL PRIMARY KEY, HabitId INTEGER NOT NULL, UNIQUE(HabitId));
CREATE TABLE Reminder_GK( ReminderId INTEGER NOT NULL PRIMARY KEY, HabitId INTEGER NOT NULL,CalendarWeekdayId INTEGER NOT NULL,IsRecurring INTEGER NOT NULL,StartTime INTEGER NOT NULL,EndTime INTEGER NOT NULL,DailyRecurringInterval INTEGER NOT NULL,IntraDayRecurringInterval INTEGER NOT NULL, UNIQUE(HabitId, CalendarWeekdayId, IsRecurring, StartTime, EndTime, DailyRecurringInterval, IntraDayRecurringInterval) );
INSERT INTO HabitCategory_GK(HabitCategoryId,HabitCategoryLevel2Name) SELECT HabitCategoryId,HabitCategoryLevel2Name FROM HabitCategory;
INSERT INTO AppSetting_GK(AppSettingId,SettingName) SELECT AppSettingId,SettingName FROM AppSetting;
INSERT INTO Comment_GK(CommentId,CommentText) SELECT CommentId,CommentText FROM Comment;
INSERT INTO GoalWeekday_GK(GoalWeekdayId,GoalId,CalendarWeekdayId) SELECT GoalWeekdayId,GoalId,CalendarWeekdayId FROM GoalWeekday;
INSERT INTO QuotePack_GK(QuotePackId,QuotePackName) SELECT QuotePackId,QuotePackName FROM QuotePack;
INSERT INTO Habit_GK(HabitId,HabitName) SELECT HabitId,HabitName FROM Habit;
INSERT INTO CommentMapping_GK(CommentMappingId,CalendarDateId,HabitId) SELECT CommentMappingId,CalendarDateId,HabitId FROM CommentMapping;
INSERT INTO HabitData_GK(HabitDataId,HabitId,CalendarDateId) SELECT HabitDataId,HabitId,CalendarDateId FROM HabitData;
INSERT INTO Goal_GK(GoalId,HabitId) SELECT GoalId,HabitId FROM Goal;
INSERT INTO HabitDetail_GK(HabitDetailId,HabitId) SELECT HabitDetailId,HabitId FROM HabitDetail;
INSERT INTO Reminder_GK(ReminderId,HabitId,CalendarWeekdayId,IsRecurring,StartTime,EndTime,DailyRecurringInterval,IntraDayRecurringInterval) SELECT ReminderId,HabitId,CalendarWeekdayId,IsRecurring,StartTime,EndTime,DailyRecurringInterval,IntraDayRecurringInterval FROM Reminder;
CREATE INDEX ix_DataCollectDeletedRows_AllColumns ON DataCollectDeletedRows(TableName ASC,RowIdDeleted ASC,DateModified ASC);
CREATE INDEX ix_HabitData_HabitDataId_DateModified ON HabitData(HabitDataId ASC,DateModified ASC);
CREATE INDEX ix_CommentMapping_CommentMappingId_DateModified ON CommentMapping(CommentMappingId ASC,DateModified ASC);